# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .agent_actions_item import AgentActionsItem
from .agent_voice import AgentVoice
from .agent_webhook import AgentWebhook


class Agent(pydantic.BaseModel):
    id: str
    user_id: str
    prompt: str
    actions: typing.List[AgentActionsItem]
    voice: AgentVoice
    initial_message: typing.Optional[str]
    webhook: typing.Optional[AgentWebhook]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        json_encoders = {dt.datetime: serialize_datetime}
